
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module DE0_NANO_SD_card(

	//////////// CLOCK //////////
	CLOCK_50,

	//////////// LED //////////
	LED,

	//////////// KEY //////////
	KEY,

	//////////// SW //////////
	SW,

	//////////// SDRAM //////////
	DRAM_ADDR,
	DRAM_BA,
	DRAM_CAS_N,
	DRAM_CKE,
	DRAM_CLK,
	DRAM_CS_N,
	DRAM_DQ,
	DRAM_DQM,
	DRAM_RAS_N,
	DRAM_WE_N,

	//////////// EPCS //////////
	EPCS_ASDO,
	EPCS_DATA0,
	EPCS_DCLK,
	EPCS_NCSO,

	//////////// GPIO_0, GPIO_0 connect to GPIO Default //////////
	GPIO,
	GPIO_IN 
);

//=======================================================
//  PARAMETER declarations
//=======================================================


//=======================================================
//  PORT declarations
//=======================================================

//////////// CLOCK //////////
input 		          		CLOCK_50;

//////////// LED //////////
output		     [7:0]		LED;

//////////// KEY //////////
input 		     [1:0]		KEY;

//////////// SW //////////
input 		     [3:0]		SW;

//////////// SDRAM //////////
output		    [12:0]		DRAM_ADDR;
output		     [1:0]		DRAM_BA;
output		          		DRAM_CAS_N;
output		          		DRAM_CKE;
output		          		DRAM_CLK;
output		          		DRAM_CS_N;
inout 		    [15:0]		DRAM_DQ;
output		     [1:0]		DRAM_DQM;
output		          		DRAM_RAS_N;
output		          		DRAM_WE_N;

//////////// EPCS //////////
output		          		EPCS_ASDO;
input 		          		EPCS_DATA0;
output		          		EPCS_DCLK;
output		          		EPCS_NCSO;

//////////// GPIO_0, GPIO_0 connect to GPIO Default //////////
inout 		    [33:0]		GPIO;
input 		     [1:0]		GPIO_IN;


//=======================================================
//  REG/WIRE declarations
//=======================================================
//TOUCHSCREEN 
wire TFT_ADC_BUSY;
wire TFT_ADC_PENIRQ_N;
wire TFT_ADC_DOUT;
wire TFT_ADC_DIN;
wire TFT_ADC_DCLK;
wire TFT_ADC_CS_N;


//TFT
wire TFT_BACKLIGHT;//PWM
wire TFT_DSIP;
wire TFT_DCLK;
wire TFT_VSYNC;
wire TFT_HSYNC;
wire TFT_DE;
wire [7:0]TFT_RED;
wire [7:0]TFT_GREEN;
wire [7:0]TFT_BLUE;



wire sdram_clk;
wire sys_clk;
wire clock_10MHz;
wire reset_n;

//=======================================================
//  Structural coding
//=======================================================

assign DRAM_CLK=sdram_clk;

pll_sys pll_sys_inst
(
	.inclk0(CLOCK_50) ,	// input  inclk0_sig
	.c0(sys_clk) ,	// output  c0_sig
	.c1(sdram_clk) ,	// output  c1_sig
	.c2(clock_10MHz) ,	// output  c2_sig
	.c3(TFT_DCLK),
	.locked(reset_n) 	// output  locked_sig
);



system u0 (
        .clk_clk              (sys_clk),              //           clk.clk
        .reset_reset_n        (reset_n),        //         reset.reset_n
	

			//EPCS		
        .epcs_sdo             (EPCS_ASDO),             //          epcs.sdo
        .epcs_data0           (EPCS_DATA0),           //              .data0
        .epcs_dclk            (EPCS_DCLK),            //              .dclk
        .epcs_sce             (EPCS_NCSO),             //              .sce
	
			//SDRAM
        .sdram_dqm            (DRAM_DQM),            //         sdram.dqm
        .sdram_ras_n          (DRAM_RAS_N),          //              .ras_n
        .sdram_cs_n           (DRAM_CS_N),           //              .cs_n
        .sdram_we_n           (DRAM_WE_N),           //              .we_n
        .sdram_dq             (DRAM_DQ),             //              .dq
        .sdram_cke            (DRAM_CKE),            //              .cke
        .sdram_addr           (DRAM_ADDR),           //              .addr
        .sdram_ba             (DRAM_BA),             //              .ba
        .sdram_cas_n          (DRAM_CAS_N),          //              .cas_n
		  
		  //UART
        .uart_0_txd           (),           //        uart_0.txd
        .uart_0_rxd           (),           //              .rxd
		  
		  //LED & SW
        .pio_led_green_export (LED[7:0]), // pio_led_green.export
        .pio_sw_export        (SW[3:0]),        //        pio_sw.export
		  
		  //SD-CARD
//        .spi_master_0_sclk    (GPIO[28]),    //  spi_master_0.sclk
//        .spi_master_0_mosi    (GPIO[26]),    //              .mosi
//        .spi_master_0_miso    (GPIO[30]),    //              .miso
//        .spi_master_0_cs      (GPIO[24]),      //              .cs
//		  
        .alt_vip_itc_0_clocked_video_vid_h_sync    (TFT_HSYNC),    //                            .vid_h_sync
        .alt_vip_itc_0_clocked_video_vid_clk       (TFT_DCLK),       //                            .vid_clkid_v
        .alt_vip_itc_0_clocked_video_vid_data      ({TFT_RED,TFT_GREEN,TFT_BLUE}),      //                            .vid_data
        .alt_vip_itc_0_clocked_video_vid_v_sync    (TFT_VSYNC),    //                            .vid_v_sync
        .alt_vip_itc_0_clocked_video_vid_datavalid (TFT_DE) //                            .vid_datavalid

    );
 


//TOUCHSCREEN
assign TFT_ADC_PENIRQ_N=GPIO_IN[0];
assign TFT_ADC_BUSY=GPIO_IN[1];
assign TFT_ADC_DOUT=GPIO[0] ;
assign GPIO[1]=TFT_ADC_DIN;
assign GPIO[2]=TFT_ADC_DCLK;		
assign GPIO[3]=TFT_ADC_CS_N;

//TFT
assign GPIO[4]=TFT_BACKLIGHT;
assign GPIO[29]=TFT_DSIP;
assign GPIO[31]=TFT_DCLK;
assign GPIO[33]=TFT_DE;

assign GPIO[32]=TFT_HSYNC;
assign GPIO[30]=TFT_VSYNC; 

//TFT Colors
assign GPIO[12:5]=TFT_RED[7:0];
assign GPIO[20:13]=TFT_GREEN[7:0];
assign GPIO[28:21]=TFT_BLUE[7:0];

//TFT ON
assign TFT_DSIP=1'b1;

reg PWM_CLK;	
always@(posedge TFT_DCLK)	
begin
	PWM_CLK<=~PWM_CLK;
end

PWM pwm_lcd(.clk(PWM_CLK), .pwm_output(TFT_BACKLIGHT), .duty_cycle(8'h80));

endmodule
